--------------------------------------------------------------------------------
-- (c) by c't magazin 
--------------------------------------------------------------------------------
--
-- Design name : CT_Lab_FPGA
-- Filename : Counter_32_Bit.vhd
-- Version : 1.0
-- Date: 13.7.2008
-- Engineer : Klaus Philipp
--
--------------------------------------------------------------------------------
-- A simple 32 Bit counter
--
--------------------------------------------------------------------------------
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
--
-- The Unisim Library is used to define Xilinx primitives. It is also used during
-- simulation. The source can be viewed at %XILINX%\vhdl\src\unisims\unisim_VCOMP.vhd
--
library unisim;
use unisim.vcomponents.all;

entity Counter_32_Bit is
   port ( CLK : in    std_logic; 
          CE  : in    std_logic; 
          CLR : in    std_logic; 
          Q   : out   std_logic_vector (31 downto 0));
end Counter_32_Bit;

architecture BEHAVIORAL of Counter_32_Bit is

signal count : std_logic_vector (31 downto 0);

begin

  counter: process(CLK, CLR, CE, count)    -- This process defines a 32 bit counter
  begin
   if CLR='1'
	then
	 count <= X"00000000";    -- If clear, set counter to zero
  elsif  rising_edge (CLK)
  then              
	 if CE='1'
	 then 
		count <= count + 1;    -- If count enable, then count
	 else
		count <= count;        -- If not count enable, then forget it
	 end if;
  end if;
	 Q <= count;                 -- Whatever happend, send count to Q
--	 Q <= X"55aacc33";           -- Test value for simulation purposes
--	 Q <= X"a0000005";           -- Test value for simulation purposes
  end process counter;

end BEHAVIORAL;


